package com.jiuqi.grid;

import java.io.Serializable;

public class CellDataProperty implements CellDataPropertyIntf, Serializable
{
    private byte dataType;
    private byte dataFlag;
    private byte editMode;
    private byte dataFormat;
    private short dataProperty;
    private GridCell cell;
    
    public CellDataProperty(final GridCell cell) {
        if (cell == null) {
            throw new IllegalArgumentException("传入的cell为null");
        }
        this.cell = cell;
    }
    
    public CellDataProperty(final int dataType, final int dataFlag, final int editMode, final int dataFormat, final int dataProperty) {
        this.dataType = (byte)dataType;
        this.dataFlag = (byte)dataFlag;
        this.editMode = (byte)editMode;
        this.dataFormat = (byte)dataFormat;
        this.dataProperty = (short)dataProperty;
    }
    
    public byte getDataType() {
        if (this.cell != null) {
            return (byte)this.cell.getDataType();
        }
        return this.dataType;
    }
    
    public void setDataType(final byte value) {
        if (value >= 0 && value <= 11) {
            if (this.cell != null) {
                this.cell.setDataType(value);
            }
            this.dataType = value;
            return;
        }
        throw new IllegalArgumentException("单元格数据类型被错误设置！");
    }
    
    public byte getDataFlag() {
        if (this.cell != null) {
            return (byte)this.cell.getDataFlag();
        }
        return this.dataFlag;
    }
    
    public void setDataFlag(final byte value) {
        if (this.cell != null) {
            this.cell.setDataFlag(value);
        }
        this.dataFlag = value;
    }
    
    public byte getEditMode() {
        if (this.cell != null) {
            return (byte)this.cell.getEditMode();
        }
        return this.editMode;
    }
    
    public void setEditMode(final byte value) {
        if (value >= 0 && value <= 9) {
            if (this.cell != null) {
                this.cell.setEditMode(value);
            }
            this.editMode = value;
            return;
        }
        throw new IllegalArgumentException("单元格编辑模式被错误设置！");
    }
    
    public byte getDataFormat() {
        if (this.cell != null) {
            return (byte)this.cell.getDataFormat();
        }
        return this.dataFormat;
    }
    
    public void setDataFormat(final byte value) {
        if (this.cell != null) {
            this.cell.setDataFormat(value);
        }
        this.dataFormat = value;
    }
    
    public short getDataProperty() {
        if (this.cell != null) {
            return (short)this.cell.getDataProperty();
        }
        return this.dataProperty;
    }
    
    public void setDataProPerty(final short value) {
        if (this.cell != null) {
            this.cell.setDataProperty(value);
        }
        this.dataProperty = value;
    }
}
